# DL_GroupParameters< T > Class Template Reference

`#include <pubkey.h>`

Inheritance diagram for DL_GroupParameters< T >:

List of all members.

## Detailed Description

### template<class T>
class DL_GroupParameters< T >

interface for DL group parameters

Definition at line 521 of file pubkey.h.

## Public Types
typedef T | Element
## Public Member Functions
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
bool | SupportsPrecomputation () const
void | Precompute (unsigned int precomputationStorage=16)
| do precomputation
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
virtual const Element & | GetSubgroupGenerator () const
virtual void | SetSubgroupGenerator (const Element &base)
virtual Element | ExponentiateBase (const Integer &exponent) const
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
virtual const DL_GroupPrecomputation < Element > & | GetGroupPrecomputation () const =0
virtual const DL_FixedBasePrecomputation < Element > & | GetBasePrecomputation () const =0
virtual DL_FixedBasePrecomputation < Element > & | AccessBasePrecomputation ()=0
virtual const Integer & | GetSubgroupOrder () const =0
virtual Integer | GetMaxExponent () const =0
virtual Integer | GetGroupOrder () const
virtual Integer | GetCofactor () const
virtual unsigned int | GetEncodedElementSize (bool reversible) const =0
virtual void | EncodeElement (bool reversible, const Element &element, byte *encoded) const =0
virtual Element | DecodeElement (const byte *encoded, bool checkForGroupMembership) const =0
virtual Integer | ConvertElementToInteger (const Element &element) const =0
virtual bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const =0
virtual bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const =0
virtual bool | FastSubgroupCheckAvailable () const =0
virtual bool | IsIdentity (const Element &element) const =0
virtual void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const =0
virtual void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &params=g_nullNameValuePairs)
| generate a random key or crypto parameters
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
virtual void | AssignFrom (const NameValuePairs &source)=0
| assign values from source to this object
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
virtual void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
void | DoQuickSanityCheck () const
template<class T>
bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T>
bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T>
bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T>
T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T>
void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
## Static Public Member Functions
static void __cdecl | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Member Functions
void | ParametersChanged ()

## Member Function Documentation

template<class T>

bool DL_GroupParameters< T >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level |
| ) |  |  | const`[inline, virtual]`

check this object for errors

Parameters:

  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time

Returns:
  true if the tests pass

Implements CryptoMaterial.

Definition at line 531 of file pubkey.h.

template<class T>

bool DL_GroupParameters< T >::SupportsPrecomputation | ( |  | ) | const`[inline, virtual]`

Returns:
  whether this object supports precomputation

Reimplemented from CryptoMaterial.

Definition at line 555 of file pubkey.h.

template<class T>

void DL_GroupParameters< T >::Precompute | ( | unsigned int | n = `16` | ) | `[inline, virtual]`

do precomputation

The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation.

Reimplemented from CryptoMaterial.

Definition at line 557 of file pubkey.h.

virtual void GeneratableCryptoMaterial::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | params = `g_nullNameValuePairs` |
| ) |  |  | `[inline, virtual, inherited]`

generate a random key or crypto parameters

Exceptions:

  | KeyingErr | if algorithm parameters are invalid, or if a key can't be generated (e.g., if this is a public key object)

Reimplemented in DL_GroupParameters_EC< EC >, InvertibleESIGNFunction, DL_GroupParameters_IntegerBased, DL_GroupParameters_DSA, InvertibleLUCFunction, DL_PrivateKeyImpl< GP >, InvertibleRabinFunction, InvertibleRSAFunction, InvertibleRWFunction, and DL_PrivateKeyImpl< DL_GroupParameters_EC< EC > >.

Definition at line 1120 of file cryptlib.h.

Referenced by GeneratableCryptoMaterial::GenerateRandomWithKeySize().

virtual void CryptoMaterial::AssignFrom | ( | const NameValuePairs & | source | ) | `[pure virtual, inherited]`

assign values from source to this object

Note:
  This function can be used to create a public key from a private key.

Implemented in DL_GroupParameters_EC< EC >, ESIGNFunction, InvertibleESIGNFunction, DL_GroupParameters_IntegerBased, DL_GroupParameters_IntegerBasedImpl< GROUP_PRECOMP, BASE_PRECOMP >, LUCFunction, InvertibleLUCFunction, RabinFunction, InvertibleRabinFunction, RSAFunction, InvertibleRSAFunction, RWFunction, InvertibleRWFunction, XTR_DH, DL_GroupParameters_IntegerBasedImpl< DL_GroupPrecomputation_LUC, DL_BasePrecomputation_LUC >, and DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation >.

virtual void CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

load key from a BufferedTransformation

Exceptions:

  | KeyingErr | if decode fails

Note:
  Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that.

Reimplemented in InvertibleRSAFunction.

Definition at line 1085 of file cryptlib.h.

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value |
| ) |  |  | const`[inline, inherited]`

get a named value with type int

used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case)

Definition at line 282 of file cryptlib.h.

Referenced by InvertibleRWFunction::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), DL_GroupParameters_DSA::GenerateRandom(), and InvertibleESIGNFunction::GenerateRandom().

The documentation for this class was generated from the following file:

- pubkey.h